package com.xynet.marketing.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xynet.marketing.utils.collections.map.JMap;

import java.util.List;
import java.util.Map;

/**
 * 会员优惠券服务
 *
 * @author hechunping
 * @date 2025/2/17
 */
public interface MemberCouponService {
    /**
     * 分页查询
     *
     * @param param
     * @return
     */
    Page<Map<String, Object>> page(JMap<String, Object> param);

    /**
     * 对象查询
     *
     * @param param
     * @return
     */
    Map<String, Object> obj(JMap<String, Object> param);

    /**
     * 新增
     *
     * @param param
     * @return
     */
    Integer saveOrUpdate(JMap<String, Object> param);

    /**
     * 列表查询
     *
     * @param param
     * @return
     */
    List<Map<String, Object>> list(JMap<String, Object> param);

    /**
     * 查询当前订单可用的优惠券
     *
     * @param param
     * @return
     */
    List<Map<String, Object>> enableList(JMap<String, Object> param);

    /**
     * 核销优惠券
     *
     * @param param
     */
    void verification(JMap<String, Object> param);
}
