package com.xynet.marketing.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * 项目设备表
 * @author hechunping
 * @date 2025/1/20
 */
@Data
@Accessors(chain = true)
@TableName("marketing_merc_project_device")
public class MercProjectDevice implements Serializable {
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 活动Id
     */
    private Integer actId;

    /**
     * 活动类型
     */
    private String actType;

    /**
     * 设备Id
     */
    private String deviceId;

    /**
     * 设备名称
     */
    private String deviceName;


}
