package com.xynet.marketing.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xynet.marketing.utils.collections.map.JMap;

import java.util.List;
import java.util.Map;

/**
 * 商家优惠券服务
 *
 * @author hechunping
 * @date 2025/2/10
 */
public interface MercCouponService {
    /**
     * 对象查询
     *
     * @param param
     * @return
     */
    Map<String, Object> obj(JMap<String, Object> param);

    /**
     * 新增或修改
     *
     * @param param
     * @return
     */
    Integer saveOrUpdate(JMap<String, Object> param);

    /**
     * 列表查询
     *
     * @param param
     * @return
     */
    List<Map<String, Object>> list(JMap<String, Object> param);

    /**
     * 分页查询
     *
     * @param param
     * @return
     */
    Page<Map<String, Object>> page(JMap<String, Object> param);

    /**
     * 单表更新（不包含商品、设备表）
     *
     * @param param
     */
    void updateSimple(JMap<String, Object> param);


    /**
     * 自动发放优惠券
     *
     * @param param
     * @return
     */
    List<Map<String, Object>> autoSend(JMap<String, Object> param);
}
