package com.xynet.marketing.service.factory.coupon.merc.impl.v2;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xynet.marketing.entity.MercCoupon;
import com.xynet.marketing.mapper.MercCouponMapper;
import com.xynet.marketing.service.factory.coupon.merc.MercCouponFactory;
import com.xynet.marketing.service.factory.coupon.merc.impl.base.MercCouponFactoryBase;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author hechunping
 * @date 2025/2/10
 */
@Service
@Slf4j
@AllArgsConstructor
public class MercCouponFactoryV2 extends ServiceImpl<MercCouponMapper, MercCoupon> implements MercCouponFactory {

    private MercCouponFactoryBase mercCouponFactoryBase;

    @Override
    public Integer saveOrUpdate(JMap<String, Object> param) {
        return mercCouponFactoryBase.saveOrUpdate(param);
    }

    @Override
    public void mercSend(JMap<String, Object> param) {
        mercCouponFactoryBase.saveOrUpdate(param);
    }

    @Override
    public void registerSend(JMap<String, Object> param) {
        mercCouponFactoryBase.registerSend(param);
    }

    @Override
    public void orderSend(JMap<String, Object> param) {
        mercCouponFactoryBase.registerSend(param);
    }

    @Override
    public List<Map<String, Object>> autoSend(JMap<String, Object> param) {
        return mercCouponFactoryBase.autoSend(param);
    }

    @Override
    public JMap<String, Object> goodsListPrice(JMap<String, Object> param) {
        return mercCouponFactoryBase.goodsListPrice(param);
    }
}
